/* Programma che genera e stampa una passeggiata aleatoria in un quadrato di dimensione 10 X 10

L'array sar riempito di caratteri (inizialmente tutti '.'). Il programma dovr muoversi di elemento in elemento spostandosi ogni volta di un passo in direzione su, gi, destra o sinistra. Gli elementi visitati andranno etichettati con le lettere dalla A alla Z, nell'ordine in cui vengono visitati.

E' importante controllare ad ogni passo che la passeggiata non esca dall'array e che non ritorni su posizioni gi visitate. Quando si verifica una di queste condizioni, provate in altre direzioni. Se tutte e quattro le direzioni sono bloccate, il programma deve uscire.

*/

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#define DIM 10

#define N 0
#define E 1
#define S 2
#define O 3


int main( void ){
  
  char quadrato[DIM][DIM];
  char k = 'Q';
  int dir, i, j, inew = 0, jnew = 0, err[4] = {0}, d;

  srand( time( NULL ) );
  
  /* inizializzazione del campo */
  for ( i = 0; i < DIM; i++ )
    for ( j = 0; j < DIM; j++ )
      quadrato[i][j] = '.';

  i = 0; j = 0;
  for ( k = 'A'; k <= 'Z'; k++ ) {
    quadrato[i][j] = k;

    /* azzero il contatore d, che indica il numero di direzioni gi provate,
      e l'array dir, che indica le direzioni bloccate */
    d = 0; 
    for ( dir = 0; dir < 4; dir++ ) 
      err[dir] = 0;		

    /* ciclo per cercare un'eventuale posizione libera */
    do { 
      dir = rand() % 4;
            
      #ifdef DEBUG
      printf( "Sono in posizione (%d, %d), ora provo con la dir %d\nerr: [%d,%d,%d,%d], direzioni gia' provate: %d\n", i, j, dir, err[0], err[1], err[2], err[3], d );
      #endif
      
      /* se ho gi verificato che questa dir  bloccata, passo all'iterata successiva */
      if ( err[dir] != 0 )
        continue;
      
      /* sto provando una direzione nuova, incremento il contatore dei tentativi */
      d++; 
      
      /* verifico se la direzione  accettabile e, nel caso, calcolo la nuova posizione */
      switch ( dir ) {
        case N:
          if ( i == 0 || quadrato[i-1][j] != '.' ) err[dir]++;
          else i--;
          break;
        case E:
          if ( j == DIM-1 || quadrato[i][j+1] != '.' ) err[dir]++;
          else j++;
          break;
        case S:
          if ( i == DIM-1 || quadrato[i+1][j] != '.' ) err[dir]++;
          else i++;
          break;
        case O:
          if ( j == 0 || quadrato[i][j-1] != '.' ) err[dir]++;
          else j--; 
      }
    } while ( err[dir] != 0 && d < 4 );
    /* Esco dal ciclo quando dir va bene ( err[dir] == 0 ) oppure 
    quando anche la quarta direzione ( d == 4 )  bloccata ( err[dir] > 0 ) */

    #ifdef DEBUG
    printf( "Sono uscita dal ciclo!\nVengo da direzione %d e sono in posizione (%d, %d)\nerr: [%d,%d,%d,%d], direzioni provate: %d\n", dir, i, j, err[0], err[1], err[2], err[3], d );
    #endif

    /* se err[dir] == 0 vuol dire che ho trovato una direzione e devo proseguire */
    if ( err[dir] == 0 ) continue;
                    
    /* altrimenti sono uscita perch d == 4 e anche la quarta direzione e' bloccata => devo uscire */
    else break;
    
  }
  
  /* stampa del campo */
  for ( i = 0; i < DIM; i++ ) {
    for ( j = 0; j < DIM; j++ )
      printf( "%c  ", quadrato[i][j] );
    printf( "\n" );
  }	
  return 0;
}
