#include<stdio.h>
#include<stdlib.h>
#include<string.h>

#define LUNG 30         /* lunghezza massima delle stringhe */
#define MAX_VOCI 3     /* numero massimo di voci in rubrica */


typedef char Stringa[LUNG];

struct voce {
   Stringa nominativo;
   Stringa telefono;
};


int main() {

  struct voce rubrica[MAX_VOCI];      /* rubrica e' un array di MAX_VOCI voci */
  int n = 0;                          /* numero di voci effettivamente inserite */
  int i, j;
  
  int comando;
  Stringa nom;

  do {
    
    printf( "\n");
    printf( "1 per inserire una voce\n2 per stampare tutta la rubrica\n0 per uscire\n" );
    printf( "Inserisci un comando: ");
    scanf( "%d", &comando );

    switch( comando ) {
    
        case 1:

          /* legge il nuovo nominativo: */
          printf( "\nInserisci un nuovo nominativo: " );
          scanf( "%s", nom );
   
          /* Ciclo che determina il valore di i corrispondente alla posizione in cui va memorizzata la nuova voce: */
          for ( i = 0; i < n; i++ )
            if ( strcmp ( rubrica[i].nominativo, nom ) > 0  ) 
              break;

          /* Se i < n sposto in avanti tutte le voci presenti in rubrica: */
          if ( i < n )
            for ( j = n; j > i; j-- )
              rubrica[j] = rubrica[j-1];

          /* assegno al nominativo della i-esima voce della rubrica il valore nom: */
          strcpy( rubrica[i].nominativo, nom );

          /* inserimento del telefono: */
          printf( "Inserisci numero di telefono (senza spazi): " );
          scanf( "%s", rubrica[i].telefono );

          n++;

          
          break;
  
        case 2: 
          printf( "\n\n* RUBRICA:\n" )
          for ( i = 0; i < n; i++ ) {
            /* riga di intestazione */
            for ( i = 0; i < LUNG; i++ )
              printf( "*");
            printf( "****\n" );
   
            /* stampa dei dati */
            printf( "* Nominativo: %s\n", v -> nominativo );
            printf( "* Telefono: %s\n", v -> telefono );
   
            /* riga di chiusura */
            for ( i = 0; i < LUNG; i++ )
              printf( "*");
            printf( "****\n" );
          }
          break;

        default:
          return 0;

    }

  } while ( 1 );


  return 0;
}


/* legge da input una nuova voce e la inserisce nella posizione corretta */
void inserisci( void ) {
   
   Stringa nom;
   int i, j;
   
   /* legge il nuovo nominativo: */
   printf( "\nInserisci un nuovo nominativo: " );
   scanf( "%s", nom );
   
   /* Ciclo che determina il valore di i corrispondente alla posizione in cui va memorizzata la nuova voce: */
   for ( i = 0; i < n; i++ )
      if ( strcmp ( rubrica[i].nominativo, nom ) > 0  ) 
         break;

   /* Se i < n sposto in avanti tutte le voci presenti in rubrica: */
   if ( i < n )
      for ( j = n; j > i; j-- )
         rubrica[j] = rubrica[j-1];

   /* assegno al nominativo della i-esima voce della rubrica il valore nom: */
   strcpy( rubrica[i].nominativo, nom );

   /* inserimento del telefono: */
   printf( "Inserisci numero di telefono (senza spazi): " );
   scanf( "%s", rubrica[i].telefono );

   n++;

}


/* stampa la voce completa puntata da v */
void stampa( struct voce *v ) {

   int i;

   if ( !v )
      printf( "Nominativo non trovato!\n" );
   
   else {
      /* riga di intestazione */
      printf( "**" );
      for ( i = 0; i < LUNG; i++ )
         printf( "*");
      printf( "**\n" );
   
      /* stampa dei dati */
      printf( "* Nominativo: %s\n", v -> nominativo );
      printf( "* Telefono: %s\n", v -> telefono );
   
      /* riga di chiusura */
      printf( "**" );
      for ( i = 0; i < LUNG; i++ )
         printf( "*");
      printf( "**\n" );
   }
   

}

void stampa_rubrica( void ) {

   int i;

   for ( i = 0; i < n; i++ ) {
      printf( "\n" );
      stampa( &rubrica[i] );
   }
   printf( "\n" );
}


/* cerca la voce con il dato nominativo e ne restituisce un puntatore.
La funzione restituisce NULL se il nominativo non e' presente in rubrica.
*/


struct voce *cerca( Stringa nom ){
   
   struct voce *v;
   

//    printf( "Sto cercando %s.....\n", nom );
   
   for ( v = &rubrica[0]; v < &rubrica[0] + n; v++ )
      if ( strcmp( v -> nominativo, nom ) == 0 )
           return v;

   return NULL;

}


struct voce *modifica( Stringa nom ) {

   struct voce *v;

   if ( v = cerca( nom ) ) {
      printf( "Inserisci il nuovo numero di telefono: " );
      scanf( "%s", v -> telefono  );
   }

   return v;
}

void elimina( Stringa nom ) {

   int i;

   printf( "n = %d\n", n );
   for ( i = 0; i < n; i++ ) {
      if ( strcmp( rubrica[i].nominativo, nom ) == 0 )
         break;
   }

   printf( "i = %d\n", i );
   if ( i < n ) {
      for ( ; i < n; i++ )
         rubrica[i] = rubrica[i+1];
      n--;
   }
   
   else 
      printf( "Nominativo non trovato!\n" );

}
